//
//	Manage MDI-type windows in content area of browser.
//

function WindowManager()
{
	this.fWindowArray = new Array();
	this.fFocusWindow = 0;
}

function MDIWindow()
{
	this.fHeight = "120";
	this.fURL = "";
	this.fName = "";
	this.fFrame = null;			// This currently doesn't get set
	this.fParent = null;		// window this one is dependent on
	this.fFrameName = "";
	this.fMessenger = null;
}

function WindowManager_LookupWindow(name)
{
	var index;
	for (index = 0; index < this.fWindowArray.length; index++)
		if (this.fWindowArray[index].fName == name)
			return this.fWindowArray[index];
			
	return null;
}

function WindowManager_OpenWindow(url, name, features, replace, messenger)
{
	var win = windowManager.LookupWindow(name);
	if (win != null) {
		top.beos.dprintf("replace existing window\n");
		// reload in the existing frame
		win.fFrame.location.href = url;
		var index;

		// Replace dependents
		for (index = 0; index < this.fWindowArray.length; index++)
			if (this.fWindowArray[index].fParent == win) {
				
			}
	} else {
		top.beos.dprintf("adding new window\n");
		// Potentially remove a window.


		// Insert a new window
		win = new MDIWindow;
		if (this.fWindowArray.length == 0)
			win.fHeight = "1*";

		win.fFrameName = "_be:content" + this.fWindowArray.length;
		win.fURL = url;
		win.fName = name;
		win.fFrame = null;	// Need to set this after layout
		this.fWindowArray[this.fWindowArray.length] = win;
	}

	this.fMessenger = messenger;
}

function WindowManager_BuildLayoutTree(layoutTree)
{
	var needDecor = false;
	var index;
	layoutTree.DeleteChildren();
	for (index = 0; index < this.fWindowArray.length; index++) {
		var win = this.fWindowArray[index];
		if (needDecor)
			layoutTree.AddFrame("_be:frame_decor", "PopUpDecor/main.html", "no", 25, true);
		else
			needDecor = true;

		layoutTree.AddFrame(win.fFrameName, win.fURL, "yes", win.fHeight, true);
//		win.fNeedsSrc = false;
	}
}

function WindowManager_GetFocusWindow()
{
	this.fWindowArray[this.fFocusWindow].GetFrame();
}

function WindowManager_RemoveWindow(index)
{
	delete this.fWindowArray[index];

	var i;
	for (i = index; i < this.fWindowArray.length - 1; i++)
		this.fWindowArray[i] = this.fWindowArray[i + 1];

	this.fWindowArray.length--;
}

function MDIWindow_GetFrame()
{
	if (this.fFrame == null)
		this.fFrame = top.find_frame(this.fFrameName);
	
	return this.fFrame;
}

WindowManager.prototype.OpenWindow = WindowManager_OpenWindow;
WindowManager.prototype.LookupWindow = WindowManager_LookupWindow;
WindowManager.prototype.BuildLayoutTree = WindowManager_BuildLayoutTree;
WindowManager.prototype.GetFocusWindow = WindowManager_GetFocusWindow;
WindowManager.prototype.RemoveWindow = WindowManager_RemoveWindow;
MDIWindow.prototype.GetFrame = MDIWindow_GetFrame;

